import unittest
from conf.testing import czifile, ilastik
from model_server.image import CziImageFileAccessor
from model_server.ilastik import IlastikPixelClassifierModel

class TestIlastikPixelClassification(unittest.TestCase):
    def setUp(self) -> None:
        self.cf = CziImageFileAccessor(czifile['path'])

    # def tearDown(self) -> None:
    #     pass

    def test_faulthandler(self): # recreate error that is messing up ilastik
        import io
        import sys
        import faulthandler

        with self.assertRaises(io.UnsupportedOperation):
            faulthandler.enable(file=sys.stdout)

    def test_instantiate_pixel_classifier(self):
        model = IlastikPixelClassifierModel({'project_file': ilastik['pixel_classifier']})
        cf = CziImageFileAccessor(czifile['path'])
        model.infer(cf.get_one_channel_data(2))

