import unittest
from conf.testing import czifile, output_path
from model_server.image import CziImageFileAccessor, write_accessor_data_to_file

class TestCziImageFileAccess(unittest.TestCase):
    def setUp(self) -> None:
        pass

    def test_czifile_is_correct_shape(self):
        cf = CziImageFileAccessor(czifile['path'])
        self.assertEqual(cf.shape_dict['Y'], czifile['h'])
        self.assertEqual(cf.shape_dict['X'], czifile['w'])
        self.assertEqual(cf.chroma, czifile['c'])
        self.assertFalse(cf.is_3d())
        self.assertEqual(len(cf.data.shape), 4)

    def test_write_single_channel_tif(self):
        ch = 2
        cf = CziImageFileAccessor(czifile['path'])
        mono = cf.get_one_channel_data(2)
        self.assertTrue(
            write_accessor_data_to_file(
                output_path / f'{cf.fpath.stem}_ch{ch}.tif',
                mono
            )
        )
        self.assertEqual(cf.data.shape[0:2], mono.data.shape[0:2])
        self.assertEqual(cf.data.shape[3], mono.data.shape[2])
